# Copyright (c) 2023 promptulate
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#
# Copyright Owner: Zeeland
# GitHub Link: https://github.com/Undertone0809/
# Project Link: https://github.com/Undertone0809/promptulate
# Contact Email: zeeland@foxmail.com

from pydantic import BaseModel

from promptulate.config import Config
from promptulate.llms.base import BaseLLM
from promptulate.memory.base import BaseChatMemory

CFG = Config()


class BasePromptFramework(BaseModel):
    role: str
    conversation_id: str
    llm: BaseLLM
    memory: BaseChatMemory

    class Config:
        arbitrary_types_allowed = True
